*==>recalib.gms		Recalibrate investment and consumption to growth path

if (uniformg,
  i0ratio(r) = (1/time_int) * ((1+g0)**time_int - srvshr) 
		/ (theta + (1-theta)*(1+g0)**time_int);
else
  gr0(r) = (ieogdp("%baseline%","2000",r)/ieogdp("%baseline%","1995",r))**(1/5) - 1;
  i0ratio(r) = (1/time_int) * ((1+gr0(r))**time_int - srvshr) 
		/ (theta + (1-theta)*(1+gr0(r))**time_int);
);

i0targ(r)  = k0(r)*i0ratio(r);
inv_adj(r) = 100 * (i0targ(r)/vom("cgd",r) - 1);
option inv_adj:0;
display inv_adj;

loop(cgd, cgdprofit(r,"before") = vom(cgd,r) - sum(j, vafm(j,cgd,r)*pai0(j,cgd,r))
				- ld0(cgd,r) - kd0(cgd,r); );

vid.l(i,r) = vafm(i,"cgd",r);
vcd.l(i,r) = c0(i,r);

vid.lo(i,r) = 0;
vid.up(i,r) = +inf;
vcd.lo(i,r) = 0;
vcd.up(i,r) = +inf;
vid.fx(i,r)$(not vafm(i,"cgd",r)) = 0;
vcd.fx(i,r)$(not c0(i,r)) = 0;

*	Fossil fuel demand for consumption and investment are
*	fixed:

vid.fx(fe,r) = vafm(fe,"cgd",r);
vcd.fx(fe,r) = c0(fe,r);

solve dbal using nlp minimizing obj;

vom("cgd",r) = i0targ(r);
vdm("cgd",r) = i0targ(r);
vi(r)	     = i0targ(r);
vafm(i,"cgd",r) = vid.l(i,r);
c0(i,r)         = vcd.l(i,r);
ct0(r)           = sum(i, c0(i,r)*pc0(i,r));

loop(cgd, cgdprofit(r,"recalib") = vom(cgd,r) - sum(j, vafm(j,cgd,r)*pai0(j,cgd,r))
				- ld0(cgd,r) - kd0(cgd,r); );
display cgdprofit;

*	Need to recalibrate public budget because adjusting investment
*	and consumption demand causes a change in tariff revenue:

vb(r) = ct0(r) + vi(r)
        - sum(f, evoa(f,r)) - sum(i, rd0(i,r))
	- sum(wmkt, mktadj(wmkt,r)*a0(wmkt,r))
	- sum(wmkt, tme(wmkt,r) * (em0(wmkt,r) + et0(wmkt,r)))
	- sum(wmkt, txe(wmkt,r) * vex0(wmkt,r))
        - sum(i,     ty(i,r)   * vom(i,r))
        - sum((i,j), ti(j,i,r) * vafm(j,i,r))
        - sum((i,f), tf(f,i,r) * vfm(f,i,r))
        - sum((i,s), tx(i,r,s)  * vxmd(i,r,s))
        - sum((i,s), tm(i,s,r)  * (vxmd(i,s,r)*(1+tx(i,s,r)) + vtwr(i,s,r)) )
        - sum(i,     tc(i,r)*c0(i,r));
vb("checksum") = sum(r, vb(r));
display vb;

*	Avoid having a carbon input with no fuel:

carbcoef(fe,i,r)$(not vafm(fe,i,r)) = 0;
carbcoef(fe,"final",r)$(not c0(fe,r)) = 0;
