*==>report.gms		Report writer for the static model

*	Define price indices:

pcnum(t) = sum(rr, pc.l(rr) * ct0(rr) * gdp(t,rr)) / sum(rr, ct0(rr)* gdp(t,rr));
pnum = sum(rr, pc.l(rr) * ct0(rr) * gdp(t,rr)) / sum(rr, ct0(rr)* gdp(t,rr));

*	Welfare index over the model horizon:

%1w(r) = w.l(r);

*	Consumer price indices:

%1cpi(t,r) = 100 * ( pc.l(r) / pcnum(t) - 1);
%1cpi(t,wmkt) = 100 * (pe.l(wmkt)/pcnum(t) - 1);
display %1cpi;


*	Present value of consumption:

%1consum(t,r) = pc.l(r) * c.l(r) * ct0(r) / pnum;

*	Capital earnings:

%1capital(t,r)$ssk = rk0 * sum(i, rk.l(i,r)*thetak(i,r)*ks(r))/pnum;
%1capital(t,r)$rsk = rk0 * sum(i, rkr.l(r)*ks(r))/pnum;
%1capital(t,r)$gk  = rk0 * sum(i, rkg.l*ks(r))/pnum;

*	GDP:

%1gdp(t,r)    = (pc.l(r)*ct0(r)*c.l(r)+sum(cgd,py.l(cgd,r)*id(r)))/pnum;
			
*	Energy demand:

%1enc(e,t,r) = ( (edf.l(e,r)/c0(e,r)) * efd(e,r) )$c0(e,r)
		+ sum(i$vafm(e,i,r), (ed.l(e,i,r)/vafm(e,i,r)) * eind(e,i,r));
%1enc("total",t,r) = sum(e, %1enc(e,t,r));

option %1enc:3:1:1;
display %1enc;

*	Energy consumption by utilities:

%1eleenc(e,t,r)$vafm(e,"ele",r) =  (ed.l(e,"ele",r)/vafm(e,"ele",r)) * eind(e,"ele",r);
option %1eleenc:3:1:1;
display %1eleenc;

*	Carbon emissions:

%1carbon(t,r) = sum(fe, cecphys(fe) * (
	 (  (edf.l(fe,r)/c0(fe,r)) *  efd(fe,r))$c0(fe,r) +
         sum(i$vafm(fe,i,r), (ed.l(fe,i,r)/vafm(fe,i,r)) * eind(fe,i,r)) )) 
	 - backstop.l(r);
%1carbon(t,"total") = sum(r,%1carbon(t,r));

*	Imports:

%1import(i,t,r,rr)$(a0(i,r)*vxmd(i,r,rr)) = imports.l(i,r,rr);

*	Terms of trade:

%1cpi(t,r) = pc.l(r) / pcnum(t);

*	Real wages:

%1wage(t,r) = pl.l(r) / pc.l(r);

%1return(t,r) = ( rkr.l(r) /pc.l(r) )$rsk
	   +  ( rkg.l / pc.l(r)   )$gk
	   +  ( sum(i, thetak(i,r)*rk.l(i,r)) / pc.l(r))$ssk;

%1rent(t,r) = sum(xe, pr.l(xe,r) * rd0(xe,r) * ffsupply(t,xe,r) * rs.l(xe,r))
			/ pc.l(r);

*	Producer price:

pindex = sum(s,ct0(s)*pc.l(s)) / sum(s, ct0(s));

%1pp(t,r,i) = py.l(i,r) / pindex;

*	Consumer price (gross of carbon tax as applicable):

%1cp(t,r,i)$(pindex * ((1 + tc(i,r)) * aeei(i,t,r) * c0(i,r) + 
			    sum(j,  (1+ti(i,j,r)) * aeei(i,t,r) * vafm(i,j,r)) ))
	= ( pa.l(i,r) * (1 + tc(i,r)) * aeei(i,t,r) * c0(i,r) + 
		pcarbon.l(r) * aeei(i,t,r) * carbcoef(i,"final",r) +
		sum(j,	pa.l(i,r) * (1+ti(i,j,r)) * aeei(i,t,r) * vafm(i,j,r) +
			pcarbon.l(r) * aeei(i,t,r) * carbcoef(i,j,r)) ) /
		(pindex * ((1 + tc(i,r)) * aeei(i,t,r) * c0(i,r) + 
			    sum(j,  (1+ti(i,j,r)) * aeei(i,t,r) * vafm(i,j,r)) ));

%1trade(t,r,wmkt) = ex.l(wmkt,r)*ex0(wmkt,r) - em.l(wmkt,r)*emc(wmkt,r);

*	Present and future value well-head prices for energy:

%1prc(whe,t,r)$eprd(whe,r) = 10 * py.l(whe,r)*VOM(whe,r)/eprd(whe,r) /pnum;

display %1prc;

*	Price of crude oil:

%1p_cru(t) = 5.3 * 10 * sum(r, VOM("cru",r)) /
		sum(r, eprd("cru",r)) * (pe.l("cru")/pcnum(t)) /0.838;

display %1p_cru;

*	Consumption:

%1c(t,r)      = 10*c.l(r)*ct0(r);
Display %1c;

*	Real output:

%1y(i,t,r)    = 10 * (y.l(i,r) + x.l(i,r)$exempt(i,r)) * VOM(i,r);
%1ttly(t,r)   = sum(i, %1y(i,t,r)) ;

*	Future value of capital:

%1k(i,t,r)    = 10 * %1capital(t,r) * pnum / pcnum(t);
%1k("all",t,r) = sum(i,%1k(i,t,r));


